<template>
  <v-card>
    <v-card-title class="title-with-close">
      <span>{{ formTitle }}</span>
      <v-spacer></v-spacer>
      <v-btn icon @click="$emit('close')">
        <v-icon>mdi-close</v-icon>
      </v-btn>
    </v-card-title>
    <v-card-text>
      <v-form @submit.prevent="onSubmit" class="generic-form">
        <div v-if="loading" class="loading">
          <v-progress-circular indeterminate></v-progress-circular>
        </div>
        <div v-else>
          <div v-for="field in fields" :key="field.name" class="form-field">
            <div v-if="field.type === 'text'" class="input-text">
              <label :for="field.name" class="input-label col-form-label">{{ field.label }}</label>
              <v-text-field
                :id="field.name"
                v-model="item[field.name]"
           
                :required="field.required"
              ></v-text-field>
            </div>
            <div v-else-if="field.type === 'select'" class="input-select">
              <v-select
                :id="field.name"
                v-model="item[field.name]"
                :items="categorias"
                item-title="nome"
                item-value="id"
                :label="field.label"
                :required="field.required"
              ></v-select>
            </div>
          </div>
          <div class="form-actions">
            <v-btn type="button" @click="$emit('close')">Close</v-btn>
            <v-btn type="submit">Salvar</v-btn>
          </div>
        </div>
      </v-form>
    </v-card-text>
  </v-card>
</template>

<script lang="ts">
import { defineComponent, PropType } from 'vue';
import { useCategoriaStore } from '../stores/categoriaStore';

export default defineComponent({
  props: {
    formTitle: {
      type: String,
      required: true
    },
    itemEdit: {
      type: Object as PropType<any>,
      required: true
    },
    fields: {
      type: Array as PropType<Array<{ name: string; label: string; type: string; required: boolean }>>,
      required: true
    }
  },
  data() {
    return {
      item: { ...this.itemEdit },
      categorias: [] as Array<{ id: number; nome: string }>,
      loading: true
    };
  },
  methods: {
    getComponentType(type: string) {
      switch (type) {
        case 'text':
          return 'v-text-field';
        case 'select':
          return 'v-select';
        default:
          return 'v-text-field';
      }
    },
    async onSubmit() {
      this.$emit('save', this.item);
    }
  },
  async mounted() {
    const categoriaStore = useCategoriaStore();
    if(categoriaStore.items.length == 0)//TODO: VERIFICA SE O ITEM ESTA VAZIO, CASO NAO ELE CARREGA.
      await categoriaStore.fetchItems('');
    this.categorias = categoriaStore.items;
    this.loading = false;
  }
});
</script>

<style scoped>
.generic-form {
  padding: 16px;
  background-color: white;
}
.form-field {
  margin-bottom: 16px;
}
.form-actions {
  display: flex;
  justify-content: space-between;
  margin-top: 16px;
}
.title-with-close {
  display: flex;
  justify-content: space-between;
  align-items: center;
}
.loading {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100px;
}
</style>
